package com.unionpay.spouts;

import java.util.Map;
import java.util.UUID;
import java.util.concurrent.ConcurrentHashMap;

import backtype.storm.spout.SpoutOutputCollector;
import backtype.storm.task.TopologyContext;
import backtype.storm.topology.OutputFieldsDeclarer;
import backtype.storm.topology.base.BaseRichSpout;
import backtype.storm.tuple.Fields;
import backtype.storm.tuple.Values;
import backtype.storm.utils.Utils;

public class SentenceSpout extends BaseRichSpout{

	//	一个可靠的单词计数需要对tuple的传输进行确认
	private ConcurrentHashMap<UUID, Values>	pending;
	private SpoutOutputCollector collector;
	
	private String[] sentences = {
			"my dog has fleas",
			"i like could beverage",
			"the dog ate my homework",
			"don't have a cow man",
			"i don't think i like fleas"
	};
	
	private  int index = 0;

	public void open(Map conf, TopologyContext context, SpoutOutputCollector collector) {
		// TODO Auto-generated method stub
		this.collector = collector;
		this.pending = new ConcurrentHashMap<UUID, Values>();
		
	}

	public void nextTuple() {
		// TODO Auto-generated method stub
		
		Values  values = new Values(sentences[index]);
		UUID msgid = UUID.randomUUID();
		this.pending.put(msgid, values);
		this.collector.emit(values,msgid);
		index++;
		if(index>=sentences.length){
			index = 0;
		}
		Utils.sleep(1);
	}

	public void declareOutputFields(OutputFieldsDeclarer declarer) {
		// TODO Auto-generated method stub
		declarer.declare(new Fields("sentence"));
	}
	
	public void ack(Object msgid){
		this.pending.remove(msgid);
	}
	
	public void fail(Object msgid){
		this.collector.emit(this.pending.get(msgid));
	}

}
