package com.unionpay.stormExample;

import com.unionpay.bolts.ReportBolt;
import com.unionpay.bolts.SplitSentenceBolt;
import com.unionpay.bolts.WordCountBolt;
import com.unionpay.spouts.SentenceSpout;

import backtype.storm.Config;
import backtype.storm.LocalCluster;
import backtype.storm.topology.TopologyBuilder;
import backtype.storm.tuple.Fields;
import backtype.storm.utils.Utils;

public class WordCountTopology {
	
	private static final String SENTENCE_SPOUT_ID = "sentence_spout";
	private static final String SPLIT_BOLT_ID = "split_bolt";
	private static final String COUNT_BOLT_ID = "count_bolt";
	private static final String REPORT_BOLT_ID = "report_bolt";
	private static final String TOPOLOGY_NAME = "word_count_topology"; 
	
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		SentenceSpout  spout = new SentenceSpout();
		SplitSentenceBolt splitBolt = new SplitSentenceBolt();
		WordCountBolt countBolt = new WordCountBolt();
		ReportBolt reportBolt = new ReportBolt();
		
		TopologyBuilder builder = new TopologyBuilder();
		builder.setSpout(SENTENCE_SPOUT_ID, spout);
		
//		设置SentenceSpout 的 executor 为 2；
//		builder.setSpout(SENTENCE_SPOUT_ID, spout, 2);
		
		builder.setBolt(SPLIT_BOLT_ID, splitBolt).shuffleGrouping(SENTENCE_SPOUT_ID);
		
//		设置SplitBolt的executor 为2，task数为4，这样，每个executor线程指派2个task；
//		builder.setBolt(SPLIT_BOLT_ID, splitBolt,2).setNumTasks(4).shuffleGrouping(SENTENCE_SPOUT_ID);
		
		builder.setBolt(COUNT_BOLT_ID, countBolt).fieldsGrouping(SPLIT_BOLT_ID, new Fields("word"));
		
//		builder.setBolt(COUNT_BOLT_ID, countBolt,4).fieldsGrouping(SPLIT_BOLT_ID, new Fields("word"));
		
		builder.setBolt(REPORT_BOLT_ID, reportBolt).globalGrouping(COUNT_BOLT_ID);
		
		Config config = new Config();
//		通过config配置类为topology增加Worker
//		config.setNumWorkers(2);
		
		LocalCluster cluster = new LocalCluster();
		
		cluster.submitTopology(TOPOLOGY_NAME, config, builder.createTopology());
		
		Utils.sleep(10000);
		
		cluster.killTopology(TOPOLOGY_NAME);
		
		cluster.shutdown();

	}

}
